<template>
  <rui-loading v-if="loading" />
  <doc-markdown-renderer v-else :raw="content" document change-page-title />
</template>

<script>
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import DocMarkdownRenderer from '@experiments-labs/rise_ui/documentation_system/components/MarkdownRenderer/MarkdownRenderer.vue'

export default {
  name: 'RootMarkdownPageView',
  components: { DocMarkdownRenderer, RuiLoading },
  data () {
    return {
      content: null,
      loading: true,
    }
  },
  computed: {
    page () { return this.$route.params.page },
  },
  methods: {
    async loadFile () {
      try {
        this.loading = true
        this.content = (await import(`../../../../${this.$route.params.page}.md?raw`)).default
        this.loading = false
      } catch (e) {
        console.error(e) // eslint-disable-line no-console
        this.$router.push({ name: '404error' })
      }
    },
  },
  created () {
    this.loadFile()
  },
  watch: {
    '$route.params.page' (newValue, oldValue) {
      if (newValue === oldValue) return

      this.loadFile()
    },
  },
}
</script>
